; sol - Conway's Soldiers, for the CSSCGC2012
;	Copyright (c) Edward Cree, 2012 <http://jttlov.no-ip.org>
;	Licensed under GNU GPL v3+; there is NO WARRANTY
; sol.asm: main program

.include	"blast.inc"

.section .main
	JP F_main

.text
.global F_main
F_main:
	LD IX,0xB000
	LD B,24
	LD C,42
	CALL F_initscr
	XOR A
	CALL F_delay
	LD BC,.isv_table
	LD A,B
	LD I,A
	IM 2
	LD DE,TBL_GMfont
	LD A,0x01
	CALL F_setfont
	LD A,0x4e
	CALL F_attrset
	CALL F_clear
	LD BC,0x0101
	LD DE,STR_title
	CALL F_mvaddstr
	LD BC,0x0204
	LD DE,STR_by
	CALL F_mvaddstr
	CALL F_refresh
	LD BC,0x0400
	LD HL,STRMAP_about
.print_about:
	LD E,(HL)
	INC HL
	LD D,(HL)
	INC HL
	PUSH BC
	PUSH HL
	CALL F_mvaddstr
	POP HL
	POP BC
	INC B
	LD A,B
	CP 0x14
	JR NZ, .print_about
	CALL F_refresh
	LD A,0x4f
	CALL F_attrset
	LD BC,0x1600
	LD DE,STR_any
	CALL F_mvaddstr
	LD A,0x4e
	CALL F_attrset
	CALL F_refresh
	CALL F_getch
	CALL F_clear
	LD BC,0x0101
	LD DE,STR_title
	CALL F_mvaddstr
	LD BC,0x0204
	LD DE,STR_by
	CALL F_mvaddstr
	CALL F_refresh
	LD BC,0x0400
	LD HL,STRMAP_instructions
.print_instructions:
	LD E,(HL)
	INC HL
	LD D,(HL)
	INC HL
	PUSH BC
	PUSH HL
	CALL F_mvaddstr
	POP HL
	POP BC
	INC B
	LD A,B
	CP 0x0e
	JR NZ, .print_instructions
	CALL F_refresh
	LD A,0x4f
	CALL F_attrset
	LD BC,0x1600
	LD DE,STR_any
	CALL F_mvaddstr
	LD A,0x4e
	CALL F_attrset
	CALL F_refresh
	CALL F_getch
	CALL F_clear
	LD HL,0x4000
.draw_grid:
	LD A,0x7
	AND H
	JR Z,.draw_1
	XOR 7
	JR Z,.draw_1
	LD A,0x81
	JR .do_draw
.draw_1:
	LD A,0x7e
.do_draw:
	LD (HL),A
	INC HL
	LD A,0x58
	CP H
	JR NZ,.draw_grid
	PUSH HL
	POP DE
	LD A,0x4e
	LD (HL),A
	INC HL
	LD BC,0x02FF
	LDIR
.main_loop:
.move_fail:
	LD HL,.mode
	LD (HL),0
.main_loop_no_modereset:
	CALL .sold_show
	CALL .curs_show
.get_key:
	CALL F_getch
	LD HL,.mode
	CP 'h'
	JR Z,.key_h
	CP 'j'
	JR Z,.key_j
	CP 'k'
	JR Z,.key_k
	CP 'l'
	JR Z,.key_l
	CP ' '
	JR Z,.key_space
	CP 'q'
	JP Z,.main_end
	CP 'u'
	JP Z,.undo
	LD (HL),0
	JR .get_key
.key_space:
	LD A,(HL)
	CPL
	LD (HL),A
	JR .main_loop_no_modereset
.key_h:
	LD A,(HL)
	AND A
	JR NZ,.move_h
	LD HL,.curx
	DEC (HL)
	JP P,.main_loop
.key_fail:
	LD (HL),0
	JR .main_loop
.key_j:
	LD A,(HL)
	AND A
	JR NZ,.move_j
	LD HL,.cury
	LD A,(HL)
	INC A
	CP 0x17
	JP M,.key_j_1
	LD A,0x17
.key_j_1:
	LD (HL),A
	JR .main_loop
.key_k:
	LD A,(HL)
	AND A
	JP NZ,.move_k
	LD HL,.cury
	DEC (HL)
	JP P,.main_loop
	LD (HL),0
	JR .main_loop
.key_l:
	LD A,(HL)
	AND A
	JP NZ,.move_l
	LD HL,.curx
	LD A,(HL)
	INC A
	CP 0x1f
	JP M,.key_l_1
	LD A,0x1f
.key_l_1:
	LD (HL),A
	JR .main_loop
.move_h:
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.curx
	DEC (HL)
	JP M,.key_fail
	DEC DE
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.curx
	DEC (HL)
	JP M,.key_fail
	DEC DE
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD A,0x81
	LD (HL),A
	INC HL
	LD A,0x7F
	AND (HL)
	LD (HL),A
	INC HL
	LD A,0x7F
	AND (HL)
	LD (HL),A
	JP .main_loop
.move_j:
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.cury
	LD A,(HL)
	INC A
	CP 0x18
	JP P,.move_fail
	LD (HL),A
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.cury
	LD A,(HL)
	INC A
	CP 0x18
	JP P,.move_fail
	LD (HL),A
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD DE,0x20
	LD A,0x82
	LD (HL),A
	AND A
	SBC HL,DE
	LD A,0x7F
	AND (HL)
	LD (HL),A
	AND A
	SBC HL,DE
	LD A,0x7F
	AND (HL)
	LD (HL),A
	JP .main_loop
.move_k:
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.cury
	DEC (HL)
	JP M,.key_fail
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.cury
	DEC (HL)
	JP M,.key_fail
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD A,0x83
	LD (HL),A
	LD DE,0x20
	ADD HL,DE
	LD A,0x7F
	AND (HL)
	LD (HL),A
	ADD HL,DE
	LD A,0x7F
	AND (HL)
	LD (HL),A
	JP .main_loop
.move_l:
	CALL .curs_ptr
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.curx
	LD A,(HL)
	INC A
	CP 0x20
	JP P,.move_fail
	LD (HL),A
	INC DE
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD HL,.curx
	LD A,(HL)
	INC A
	CP 0x20
	JP P,.move_fail
	LD (HL),A
	INC DE
	LD HL,.grid
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD A,0x84
	LD (HL),A
	DEC HL
	LD A,0x7F
	AND (HL)
	LD (HL),A
	DEC HL
	LD A,0x7F
	AND (HL)
	LD (HL),A
	JP .main_loop
.undo:
	CALL .curs_ptr
	LD HL,.grid
	AND A
	ADC HL,DE
	LD A,(HL)
	AND 0x80
	JP Z,.move_fail
	LD A,(HL)
	AND 7
	JP Z,.move_fail
	DEC A
	JP Z,.undo_h
	DEC A
	JR Z,.undo_j
	DEC A
	JR Z,.undo_k
	DEC A
	JP NZ,.main_loop
.undo_l:
	DEC HL
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	DEC HL
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD A,(HL)
	OR 0x80
	LD (HL),A
	INC HL
	LD A,(HL)
	OR 0x80
	LD (HL),A
	INC HL
	LD A,(HL)
	AND 0x7F
	LD (HL),A
	LD HL,.curx
	DEC (HL)
	DEC (HL)
	JP .main_loop
.undo_k:
	LD DE,0x20
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD A,(HL)
	OR 0x80
	LD (HL),A
	LD DE,-0x20
	ADD HL,DE
	LD A,(HL)
	OR 0x80
	LD (HL),A
	ADD HL,DE
	LD A,(HL)
	AND 0x7F
	LD (HL),A
	LD HL,.cury
	INC (HL)
	INC (HL)
	JP .main_loop
.undo_j:
	LD DE,-0x20
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	ADD HL,DE
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD A,(HL)
	OR 0x80
	LD (HL),A
	LD DE,0x20
	ADD HL,DE
	LD A,(HL)
	OR 0x80
	LD (HL),A
	ADD HL,DE
	LD A,(HL)
	AND 0x7F
	LD (HL),A
	LD HL,.cury
	DEC (HL)
	DEC (HL)
	JP .main_loop
.undo_h:
	INC HL
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	INC HL
	LD A,(HL)
	AND 0x80
	JP NZ,.move_fail
	LD A,(HL)
	OR 0x80
	LD (HL),A
	DEC HL
	LD A,(HL)
	OR 0x80
	LD (HL),A
	DEC HL
	LD A,(HL)
	AND 0x7F
	LD (HL),A
	LD HL,.curx
	INC (HL)
	INC (HL)
	JP .main_loop
.main_end:
	IM 1
	LD BC,0
	RET
.sold_show:
	LD HL,.grid
	LD DE,0x5800
.sold_next:
	LD A,(HL)
	AND 0x80
	LD A,0x4e
	JR Z,.sold_done
	LD A,0x71
.sold_done:
	LD (DE),A
	INC DE
	INC HL
	LD A,D
	CP 0x5B
	JR NZ,.sold_next
	RET
.curs_ptr:
	LD A,(.cury)
	LD E,A
	LD A,(.curx)
	LD D,0
	SLA E
	RL D
	SLA E
	RL D
	SLA E
	RL D
	SLA E
	RL D
	SLA E
	RL D
	ADD A,E
	LD E,A
	JR NC,.curs_ptr_1
	INC D
.curs_ptr_1:
	AND A
	RET

.curs_show:
	CALL .curs_ptr
	LD HL,.grid
	ADC HL,DE
	LD A,(HL)
	AND A
	LD HL,0x5800
	ADC HL,DE
	LD B,A
	AND 0x80
	LD (HL),0x42
	RET Z
	LD (HL),0x50
	RET

.data
.curx:.defb 15
.cury:.defb 5
.mode:.defb 0
.grid:.fill 160,1,0
.fill 608,1,0x80

.section isr
.skip 0x89
.isr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
	PUSH IX
	LD IX,0xB000
	CALL F_input_isv
	POP IX
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI

.data
.balign 0x100
.isv_table:
.fill 257,1,0x89
TBL_GMfont: .incbin "GenevaMono.font"

STR_title: .asciz "Conway's Soldiers"
STR_by: .asciz "by AY Chip"
STR_any: .asciz "Press any key"

STRMAP_about:
.defw STR_about_1
.defw STR_about_2
.defw STR_about_3
.defw STR_about_4
.defw STR_about_5
.defw STR_about_6
.defw STR_about_7
.defw STR_about_8
.defw STR_about_9
.defw STR_about_10
.defw STR_about_11
.defw STR_about_12
.defw STR_about_13
.defw STR_about_14
.defw STR_about_15
.defw STR_about_16
STR_about_1: .asciz "Conway's Soldiers is a solitaire game,"
STR_about_2: .asciz "invented by mathematician John Horton"
STR_about_3: .asciz "Conway in 1961.  As in peg solitaire, a"
STR_about_4: .asciz "move consists of one soldier jumping over"
STR_about_5: .asciz "an adjacent soldier into an empty cell,"
STR_about_6: .asciz "vertically or horizontally (but not"
STR_about_7: .asciz "diagonally), and removing the soldier"
STR_about_8: .asciz "which was jumped over. The object of the"
STR_about_9: .asciz "game is to place a soldier as far above"
STR_about_10: .asciz "the horizontal line as possible."
STR_about_11: .asciz "It can be shown that the fifth rows above"
STR_about_12: .asciz "the line cannot be reached in finitely"
STR_about_13: .asciz "many moves, but if the grid were infinite"
STR_about_14: .asciz "it could be reached in an infinite number"
STR_about_15: .asciz "of moves (the latter result was proved by"
STR_about_16: .asciz "Simon Tatham and Gareth Taylor)."

STRMAP_instructions:
.defw STR_instruc_1
.defw STR_instruc_2
.defw STR_instruc_3
.defw STR_instruc_4
.defw STR_instruc_5
.defw STR_instruc_6
.defw STR_instruc_7
.defw STR_instruc_8
.defw STR_instruc_9
.defw STR_instruc_10
STR_instruc_1: .asciz "Instructions:"
STR_instruc_2: .asciz "Move the cursor with hjkl (vi keys: h=left"
STR_instruc_3: .asciz "j=down k=up l=right).  To move the piece"
STR_instruc_4: .asciz "under the cursor, press spacebar followed"
STR_instruc_5: .asciz "by a direction (any key other than hjkl"
STR_instruc_6: .asciz "will cancel).  To undo a move, press 'u'"
STR_instruc_7: .asciz "with the cursor over the piece you want to"
STR_instruc_8: .asciz "move back.  Note however that long chains"
STR_instruc_9: .asciz "of moves which cross over themselves may"
STR_instruc_10: .asciz "not be able to be undone."
